#
# spec file for package libcgroup1
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           libcgroup1
Version:        0.36.2
Release:        6.3.1
License:        LGPLv2.1
Group:          System/Management
AutoReqProv:    on
Summary:        Control groups management tools
Url:            http://sourceforge.net/projects/libcg/
Source:         http://dl.sourceforge.net/sourceforge/libcg/libcgroup-%{version}.tar.bz2
Source1:        initd_cgconfig
Source2:        initd_cgred
Source3:        sysconfig.cgred
Source99:       baselibs.conf
Patch0:         cgrulesengd-deny-message-forging.patch
Patch1:         libcgroup-CVE-2011-1006.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  bison flex gcc-c++ pam-devel pkg-config
Requires:       insserv pam

%description
Control groups, a new kernel feature in Linux 2.6.24 provides a file
system interface to manipulate and control the details on task grouping
including creation of new task groups (control groups), permission
handling and task assignment.



Authors:
--------
    Balbir Singh <balbir_singh@users.sourceforge.net>
    Dhaval Giani <dhaval_giani@users.sourceforge.net>

%package -n libcgroup-devel
License:        LGPLv2.1
Summary:        Control groups management tools devel package
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}-%{release}

%description -n libcgroup-devel
Control groups, a new kernel feature in Linux 2.6.24 provides a file
system interface to manipulate and control the details on task grouping
including creation of new task groups (control groups), permission
handling and task assignment.



Authors:
--------
    Balbir Singh <balbir_singh@users.sourceforge.net>
    Dhaval Giani <dhaval_giani@users.sourceforge.net>

%prep
%setup -n libcgroup-%{version}
%patch0 -p1
%patch1 -p1

%build
%configure --enable-pam-module-dir=/%{_lib}/security
export V=1
make

%install
%makeinstall
find $RPM_BUILD_ROOT -type f -name '*.la' -exec rm -f {} ';'
rm -f $RPM_BUILD_ROOT/%{_lib}/security/*.so.* 
mkdir -p %{buildroot}/%{_sysconfdir}/init.d/
install -m 755 %{SOURCE1} %{buildroot}/%{_sysconfdir}/init.d/cgconfig
install -m 755 %{SOURCE2} %{buildroot}/%{_sysconfdir}/init.d/cgred
mkdir -p %{buildroot}/%{_localstatedir}/adm/fillup-templates/
install -m 644 %{SOURCE3} %{buildroot}/%{_localstatedir}/adm/fillup-templates/sysconfig.cgred

# remove setuid
chmod u-s $RPM_BUILD_ROOT/%{_bindir}/cgexec

# move lib to rootfs
libcgso=$(basename $RPM_BUILD_ROOT/%{_libdir}/libcgroup.so.*.*.*)
mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT/%{_libdir}/libcgroup.so.*.*.* $RPM_BUILD_ROOT/%{_lib}
rm -f $RPM_BUILD_ROOT/%{_libdir}/libcgroup.so.1
ln -sf $libcgso $RPM_BUILD_ROOT/%{_lib}/libcgroup.so.1
ln -sf ../../%{_lib}/$libcgso $RPM_BUILD_ROOT/%{_libdir}/libcgroup.so

%clean
rm -rf %{buildroot}

%preun
%{stop_on_removal cgred}
%{stop_on_removal cgconfig}

%post
%{fillup_and_insserv -f cgconfig}
%{fillup_and_insserv -n cgred}
%{run_ldconfig}

%postun
%{insserv_cleanup}
%{run_ldconfig}

%files
%defattr(-,root,root)
%doc COPYING
%doc README
%doc README_daemon
%doc INSTALL
%doc samples/cgconfig.conf
%doc samples/cgrules.conf
%{_sysconfdir}/init.d/cgconfig
%{_sysconfdir}/init.d/cgred
%{_bindir}/cg*
%{_bindir}/ls*
%{_sbindir}/cg*
/%{_lib}/libcgroup.so.*
/%{_lib}/security/pam_cgroup.so
%{_localstatedir}/adm/fillup-templates/sysconfig.cgred
%{_mandir}/man[^3]/*

%files -n libcgroup-devel
%defattr(-,root,root)
%{_libdir}/libcgroup.so
%{_includedir}/libcgroup.h
%dir %{_includedir}/libcgroup
%{_includedir}/libcgroup/*.h
%{_libdir}/pkgconfig/libcgroup.pc

%changelog
* Mon Feb 28 2011 jslaby@suse.de
- verify the sender of netlink messages (bnc#675048, CVE-2011-1022)
- fix buf overflow (bnc#675506, CVE-2011-1006)
* Mon Jul  5 2010 jslaby@suse.de
- update to 0.36.2 final
* Fri Jun  4 2010 kay.sievers@novell.com
- update to 0.36.2.rc
  - install pkg-config file
  - do not call exit() on error
- drop all patches which are upstream now or no longer needed
- install library in the rootfs, not in /usr
- enable verbose build
* Fri Feb  5 2010 jslaby@suse.de
- really fail to start (forgotten %%patch3)
* Thu Feb  4 2010 jslaby@suse.de
- fail to start when a parsing error occurs (bnc#576932)
* Mon Feb  1 2010 jengelh@medozas.de
- package baselibs.conf
* Tue Aug 18 2009 jslaby@suse.de
- update init scripts. cgred moved to /usr/sbin/
* Wed Jun 24 2009 sbrabec@suse.cz
- Supplement pam-32bit/pam-64bit in baselibs.conf (bnc#354164).
* Mon May  4 2009 jslaby@suse.de
- update to 0.33
- refresh patches and make them -p1
- add pam module and manpages
* Fri Jan  2 2009 jslaby@suse.de
- Update to 0.32.2
- Fix devel package group (to Development/Libraries)
- Fix cgred init script
- Update cgconfig init script to create a default cgroup (bnc#458611)
* Thu Nov  6 2008 jslaby@suse.cz
- Update to 0.32.1
- Add init.d scripts configuration samples.
* Mon Oct 20 2008 schwab@suse.de
- Fix invalid use of sigaction.
* Wed Oct 15 2008 kukuk@suse.de
- Fix typo
* Tue Oct 14 2008 kukuk@suse.de
- Fix name of devel package
* Wed Oct  1 2008 jslaby@suse.cz
- initial package
